<template>
  <div class="welcome page" :class="{loading: isLoading == true}" :style="{'backgroundImage': 'url('+bgImg+')'}">
      <div class="page-wrapper">
        <img :src="this.$logoimg" width="110"/>
        <div class="space-md"></div>
        <h1 class="font-size-title">“解码轩尼诗”互动体验展</h1>
        <div class="space-sm"></div>
        <img :src="scanIcon" width="181"/>
        <div class="space-sm"></div>
        <div v-if="isFocus == true">
          <div class="font-size-heading">请扫描您的专属二维码</div>
        </div>
        <div v-if="isFocus == false">
          <a class="btn-brand btn-lg" @click="focusInput">開始</a>
        </div>
        <!--div><input id="qrInput" :value="userId" /></div-->
        <div id="qrInput" v-text="userId"></div>
      </div>
  </div>
</template>

<script>
import JQuery from 'jquery'

export default {
  name: 'Welcome',
  data () {
    return {
      isLoading: false,
      api: this.getApi(),
      bgImg: require('../../assets/bg_season.jpg'),
      currentVenue: this.getCookie("Entrance_hennessy_venue"),
      userId: '',
      scanIcon: require('../../assets/scan-icon.png'),
      keyboardTimeout: 2000,
      timeoutFn: function(){},
      isFocus: false,
    }
  },
  watch: {
  },
  methods: {
    getApi: function(){
      if(this.$config.venue == '' || this.$config.venue == 'undefined' || this.$config.venue  == null){
        this.$router.push('/config') //success -> goto ticket 
        return false;
      }
      return this.$config.api_url[this.$config.venue].api_prefix
    },
    focusInput: function(){
      this.isFocus = true;
    },
    scanQr: function(code){
      var vm  = this;
      vm.userId = vm.userId.replace('Enter', '');
      var submitData = {
        userId: vm.userId
      }
      vm.isLoading = true;
      JQuery.post(vm.api + '/api/getUserTicket',submitData)
      .done(function(response){
        vm.isLoading = false;
        console.log(vm.api + '/api/getUserTicket : response: ', response);
        if(response.result == 1){
          var data = response.data;
          vm.$config.user = Object.assign({},data)
          vm.$router.push('/ticket')
        }else{
          vm.$router.push('/fail')
        }
      })
      .fail(function(){
        vm.isLoading = false;
        vm.$router.push('/fail')
        //alert("server error.")
        //vm.userId = ""
      })
      /*vm.$axios
      .post(vm.api + '/api/getUserTicket', submitData, {
        headers: {
          'Acces-Control-Allow-Origin': '*'
        }
      })
      .then(function(response){
        console.log(vm.api + '/api/getUserTicket : response: ', response);
        var data = response.data;
        return;
        vm.$config.user = Object.assign({},data)
        vm.$router.push('/ticket') //success -> goto ticket
        //vm.$router.push('/fail') //fail -> wrong qr pattern
      })
      .catch(function(error){
        console.log(error)
      })*/
      
      /*var sampleReturn = {
        userName: 'chukei',
        userId: vm.userId,
        tickets: [
          {
            name: '轩尼诗“食”验室',
            date: '2018年11月23日',
            time: '14:00－14：30'
          },{
            name: '轩尼诗陈酿的艺术' ,
            date: '2018年11月25日',
            time: '15:00－15:30'
          },{
            name: '轩尼诗陈酿的艺术',
            date: '2018年11月25日',
            time: '15:00－15:30'
          }
        ]
      }*/
    },
    onKeyboardFn: function(e){
      var vm = this;
      if(vm.isLoading == true){
        return;
      }
      clearTimeout(vm.timeoutFn);
      const currentCode = event.which || event.code;
      let currentKey = event.key;
      if (!currentKey) {
        currentKey = String.fromCharCode(currentCode);
      }
      vm.userId = vm.userId + currentKey;

      if(vm.userId.indexOf('Enter') > 0){
        vm.scanQr();
      }
      /*vm.timeoutFn = setTimeout(function(){
        vm.scanQr();
      },vm.keyboardTimeout);*/
    },
    evt: function(){
      var vm = this;
      window.addEventListener('keypress', vm.onKeyboardFn)
    },
    unbindEvt: function(){
      var vm = this;
      window.removeEventListener('keypress', vm.onKeyboardFn)
    },
    checkCookie: function(){
      var vm = this;
      var hennessy_venue = vm.getCookie("Entrance_hennessy_venue");

      if (hennessy_venue == 'shanghai') {
        vm.$config.venue = hennessy_venue;
      }else if( hennessy_venue =='malaysia' ){
        vm.$config.venue = hennessy_venue;
      }
      
      if( hennessy_venue == '' || hennessy_venue == 'underfined' || hennessy_venue == null ){
        vm.$router.push({ 
          path: '/config' 
        })
      }
    },
    getCookie: function(cname) {
      var name = cname + "=";
      var decodedCookie = decodeURIComponent(document.cookie);
      var ca = decodedCookie.split(';');
      for(var i = 0; i <ca.length; i++) {
          var c = ca[i];
          while (c.charAt(0) == ' ') {
              c = c.substring(1);
          }
          if (c.indexOf(name) == 0) {
              return c.substring(name.length, c.length);
          }
      }
      return "";
    }
  },
  mounted: function(){
    this.$config.userId = '';
    this.checkCookie();
    this.evt();
    this.isFocus = true;
  },
  beforeDestroy() {
    this.unbindEvt();
    this.isFocus = false;
  },
  
}
</script>

<style lang="sass">
@import "../../styles/index.sass"
</style>
